<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/

define('ELISA_CONF_GUI','/usr/share/elisa/conf/elisa.gui.conf');
define('ELISA_CONF','/usr/share/elisa/conf/elisa.conf');


$DISABLE_INDICE_DELETE = shell_exec('grep -i DISABLE_INDICE_DELETE= '.ELISA_CONF.' | cut -d= -f2 | cut -d# -f1');
define('DISABLE_INDICE_DELETE',trim($DISABLE_INDICE_DELETE));

require_once dirname(__FILE__).'/include/config.inc.php';
require_once dirname(__FILE__).'/include/js.inc.php';
require_once dirname(__FILE__).'/include/users.inc.php';
require_once dirname(__FILE__).'/include/forms.inc.php';

$config = select_config();
$userdata = getUserFormData(CWebUser::$data['userid'], $config, true);
if($userdata['lang'] == "cs_CZ"){
	define('ELISA_CONF_HELP','/usr/share/elisa/conf/elisa.gui.help.cs');
}else{
	define('ELISA_CONF_HELP','/usr/share/elisa/conf/elisa.gui.help');
}



$page['title'] = _('ELISA Options');
$page['file'] = 'elisa_config.php';
$page['hist_arg'] = array();

require_once dirname(__FILE__).'/include/page_header.php';

$themes = array_keys(Z::getThemes());
$themes[] = THEME_DEFAULT;

// VAR	TYPE	OPTIONAL	FLAGS	VALIDATION	EXCEPTION
$fields = array(
	'items'=>					array(T_ZBX_STR, O_OPT, P_SYS,			null,	null),
	// actions
	'update'=>					array(T_ZBX_STR, O_OPT, P_SYS|P_ACT,	null,	null),
	'form_refresh' =>			array(T_ZBX_INT, O_OPT,	null,	null,	null)
);
check_fields($fields);

/*
 * Actions
 */
$result = true;
$result1 = true;
if (hasRequest('update')) {
	$configItems = getRequest('items', array());
	$fileContent = '';
	
	$conf = array();
	$file = fopen(ELISA_CONF_GUI,"r");
	while(! feof($file)){
		$line = fgets($file);
		if(!is_int(strpos($line, '#')) && trim($line) != ""){
			$lineArr = explode("=",$line);
			$key = trim($lineArr[0]);
			$value = trim($lineArr[1]);
			$conf[$key] = $value;
		}
	}
	fclose($file);	
	
	$message_err = _('Cannot update ELISA configuration');
	foreach ($configItems as $key => $value) {
		if (array_key_exists($key, $conf)) {
			if(strpos($key, '_ALIAS') !== false) {
				$value = $value;	
			}else{
				$value = (int)$value;		
				if(!is_int($value)){ $value=0; }	
			}
			if( $key == "DATA_RETENTION_DELETE" && DISABLE_INDICE_DELETE == "TRUE" ){
				// zachovavam stejnou hodnotu, jaka byla v konf souboru - nedovolim jeji prepsani
			}else if( $key == "DATA_RETENTION_ARCHIVEDELETE" && DISABLE_INDICE_DELETE == "TRUE" ){
				// zachovavam stejnou hodnotu, jaka byla v konf souboru - nedovolim jeji prepsani
			}else if( $key == "DATA_RETENTION_COMPRESS"){
				if($value<(int)$configItems["DATA_RETENTION_DELETE"]){
					$conf[$key] = $value;
				}else{
					$result1 = false;
					$message_err = _('Archive indice value must be smaller than Delete indice');
				}
			}else{
				$conf[$key] = $value;
			}
		}else{
			if( $key == "rawdata" ){
				$itemRawSend = API::Item()->get([
					'output' => ['itemid'],
					'templated' => true,
					'search' => [ "key_" => "xlog.config[AGENT,Input,*,SendToElisaRaw]" ],
					'searchWildcardsEnabled' => true
				]);
				$items = [];
				$status = 0; if($value==0){$status=1;}
				foreach ($itemRawSend as $item) {
					$items[] = ['itemid' => $item['itemid'], 'status' => $status];
				}
				$result = (bool) API::Item()->update($items);

			}
		}
	}
	
	foreach ($conf as $key => $value) {
		$fileContent .= $key."=".$value."\n";
		add_audit_details(AUDIT_ACTION_UPDATE, 99, 0, $key."=".$value, 'settings');
	}	
	
	$result = file_put_contents(ELISA_CONF_GUI,$fileContent);
	//exec('sudo /usr/share/elisa/bin/elisa-clusterSync.sh', $output, $rci);
	show_messages($result && $result1, _('ELISA configuration updated'), $message_err);
}

/*
 * Display
 */
 
$data = array();

$file = fopen(ELISA_CONF_GUI,"r");
while(! feof($file)){
	$line = fgets($file);
	if(!is_int(strpos($line, '#')) && trim($line) != ""){
		$lineArr = explode("=",$line);
		$key = trim($lineArr[0]);
		$value = trim($lineArr[1]);
		if($key=="DATA_RETENTION_COMPRESS"){}
		else if($key=="DATA_RETENTION_ARCHIVEDELETE"){}
		else if($key=="BACKUP_DELETE"){}
		else if($key=="BACKUP_ZABBIX_HISTORY_DATA"){}
		else if(strpos($key, 'DATA_BUCKET_') !== false){}
		else{$data['config'][$key] = $value;}
	}
}
fclose($file);

$file = fopen(ELISA_CONF_HELP,"r");
while(! feof($file)){
	$line = fgets($file);
	if(strpos($line, '#') == FALSE && trim($line) != ""){
		$lineArr = explode(";",$line);
		$key = trim($lineArr[0]);
		$category = trim($lineArr[1]);
		$label = trim($lineArr[2]);
		if(count($lineArr)>3){$hint = trim($lineArr[3]);}else{$hint='';}
		if(count($lineArr)>4){$htmlType = trim($lineArr[4]);}else{$htmlType='text';}
		$data['help'][$key] = array(
			'category' => $category,
			'label' => $label,
			'hint' => $hint,
			'htmlType' => $htmlType
		);
	}
}
fclose($file);

$itemRawSend = API::Item()->get([
		'output' => ['key_','itemid','status'],
		'templated' => true,
		'search' => [ "key_" => "xlog.config[AGENT,Input,*,SendToElisaRaw]" ],
		'searchWildcardsEnabled' => true
	]);
if(count($itemRawSend)>0){
	$data['help']['rawdata'] = [
		'category' => _('Forensic'),
		'label' => _('Save Forensic Raw data'),
		'hint' => _('Raw data would be saved separately. Disk space requirements is doubled.'),
		'htmlType' => 'checkbox'
	];
	if($itemRawSend[0]['status']==0){
		$data['config']['rawdata'] = 1;
	}else{
		$data['config']['rawdata'] = 0;
	};
}

$data['bucket'] = [];
$file = fopen(ELISA_CONF_GUI,"r");
while(! feof($file)){
	$line = fgets($file);
	if(!is_int(strpos($line, '#')) && trim($line) != ""){
		$lineArr = explode("=",$line);
		$key = trim($lineArr[0]);
		$value = trim($lineArr[1]);
		if(strpos($key, 'DATA_BUCKET_') !== false){
			$keyArr = explode("_",$key);
			$key_index = trim($keyArr[2]);
			$key_name = trim($keyArr[3]);
			$data['bucket'][$key_index][$key_name] = $value;
		}
	}
}
fclose($file);



if( DISABLE_INDICE_DELETE == "TRUE" ){ $data['DISABLE_INDICE_DELETE']=true; }else{ $data['DISABLE_INDICE_DELETE']=false; }
// render view

$configView = new CView('elisa.config', $data);
$configView->render();
$configView->show();




require_once dirname(__FILE__).'/include/page_footer.php';
