<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/

define('MIB_DIRECTORY','/usr/share/snmp/mibs');
define('MIB_UPLOAD','sudo /usr/share/elisa/bin/elisa-mibUpload.sh');
//define('MIB_STATUS','/bin/systemctl status snmptrapd.service | grep Active');

require_once dirname(__FILE__).'/include/config.inc.php';
require_once dirname(__FILE__).'/include/js.inc.php';


$page['title'] = _('ELISA SNMP');
$page['file'] = 'elisa_snmp.php';
$page['hist_arg'] = array();

require_once dirname(__FILE__).'/include/page_header.php';

$themes = array_keys(Z::getThemes());
$themes[] = THEME_DEFAULT;

// VAR	TYPE	OPTIONAL	FLAGS	VALIDATION	EXCEPTION
$fields = array(
	'import' => [T_ZBX_STR, O_OPT, P_SYS|P_ACT, null, null],
	'cancel' => [T_ZBX_STR, O_OPT, P_SYS, null, null]
);
check_fields($fields);



/*
 * Actions
 */

$result = true;
	if(sizeof($_FILES)>0){
		$uploaddir = '/usr/share/elisa/portal/uploaded_mibs/';
		$uploadfilename = '';
		if(isset($_FILES['mibfile'])){
			$uploadmessage_ok = '';
			$uploadmessage_err = '';
			if($_FILES['mibfile']['error']==0){
				$uploadfile = $uploaddir . basename($_FILES['mibfile']['name']);
				if (move_uploaded_file($_FILES['mibfile']['tmp_name'], $uploadfile)) {
					$uploadfilename = pathinfo($uploadfile, PATHINFO_FILENAME);
					$mibUploadStatus = shell_exec(MIB_UPLOAD);
					$uploadmessage_ok = _('MIB file has been sucessfully uploaded');		
					add_audit_details(AUDIT_ACTION_ADD, 99, 0, $_FILES['mibfile']['name'], 'snmp-mib');
				} else {
					$uploadmessage_err = _('Error occured during file upload');
				}						
			}else{
				$uploadmessage_err = _('Error occured during file upload');
			};
		}	
		exec('sudo /usr/share/elisa/bin/elisa-clusterSync.sh', $output, $rci);
		show_messages($result, $uploadmessage_ok, $uploadmessage_err);
	}	


/*
 * Display
 */


	
$data = [];	
$data['backurl']='elisa_snmp.php'; 
//$data['currentCrt']=$currentCrt; 



// render view
$snmpView = new CView('elisa.snmp', $data);
$snmpView->render();
$snmpView->show();




require_once dirname(__FILE__).'/include/page_footer.php';
