<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


$archiveWidget = (new CWidget())->setTitle(_('Archive'));


$archiveTab = new CTabView();

	$config = $this->data['config'];
	$help = $this->data['help'];
	
	
	$archiveNfsForm = new CForm();
	$archiveNfsForm->setName('archiveNfsForm');

	$configNfsFormList = new CFormList('archiveNfsForm');
	
	if($config['nfs']!=""){
		$configNfsFormList->addRow(new CLabel($help['nfs']['label']), new CSpan($config['nfs']));
		$configNfsFormList->addRow(new CLabel($help['nfsavail']['label']), new CSpan($config['nfsavail']));
		$configNfsFormList->addRow(new CSubmit('umount', _('Umount')));
		$configNfsFormList->addRow(new CSpan(''));

		$ret1Box = (new CTextBox('DATA_RETENTION_COMPRESS', $config['DATA_RETENTION_COMPRESS'], false, ZBX_TEXTAREA_STANDARD_WIDTH))->addStyle('width: 5em');
		$ret1Label = new CLabel($help['DATA_RETENTION_COMPRESS']['label']);
		if($help['DATA_RETENTION_COMPRESS']['hint']!=null){$ret1Label->setHint($help['DATA_RETENTION_COMPRESS']['hint'],'',false);}
		$configNfsFormList->addRow($ret1Label, $ret1Box);

		$ret2Box = (new CTextBox('DATA_RETENTION_ARCHIVEDELETE', $config['DATA_RETENTION_ARCHIVEDELETE'], false, ZBX_TEXTAREA_STANDARD_WIDTH))->addStyle('width: 5em');
		$ret2Label = new CLabel($help['DATA_RETENTION_ARCHIVEDELETE']['label']);
		if($help['DATA_RETENTION_ARCHIVEDELETE']['hint']!=null){$ret2Label->setHint($help['DATA_RETENTION_ARCHIVEDELETE']['hint'],'',false);}
		$configNfsFormList->addRow($ret2Label, $ret2Box);
		
		$configNfsFormList->addRow(new CSubmit('update', _('Update')));
		
	}else{
		$nfsBox = (new CTextBox('nfs', $config['nfs'], false, ZBX_TEXTAREA_STANDARD_WIDTH))->addStyle('width: 30em');
		$nfsLabel = new CLabel($help['nfs']['label']);
		if($help['nfs']['hint']!=null){$nfsLabel->setHint($help['nfs']['hint'],'',false);}
		$configNfsFormList->addRow($nfsLabel, $nfsBox);
		$configNfsFormList->addRow(new CSubmit('mount', _('Mount')));
		//$configNfsFormList->addRow(new CSpan(''));
		//$configNfsFormList->addRow(new CLabel($help['DATA_RETENTION_COMPRESS']['label']), new CSpan($config['DATA_RETENTION_COMPRESS']));
		//$configNfsFormList->addRow(new CLabel($help['DATA_RETENTION_ARCHIVEDELETE']['label']), new CSpan($config['DATA_RETENTION_ARCHIVEDELETE']));
	}


	$archiveNfsForm->addItem($configNfsFormList);


	$archiveTab->addTab('config', _('Configuration'), $archiveNfsForm);
	
	
	$archiveTable = new CTableInfo(_('No DB archives found.'));
	$archiveTable->setHeader(array(
		'',
		_('Name'),
		_('Creation Date'),
		_('Size'),
		_('Action')
	));
	foreach ($this->data['indice'] as $name => $indice) {
		$creationDate = $indice['creationDate']/1000;
		if($creationDate>0){
			$creationDateTxt = date('d.m.Y H:i:s',$creationDate);
		}else{
			$creationDateTxt = '';
		}
		if(array_key_exists('size_in_bytes',$indice) && !is_null($indice['size_in_bytes'])){
			$sizeOpt = array(
				'value' => $indice['size_in_bytes'],
				'units' => 'B'
			);
			$size = convert_units($sizeOpt);
		}else{
			$size = '';
		}		

		$archiveTable->addRow(array(
			new CCheckBox('indicesid['.$name.']', $name),
			new CCol($name, 'wraptext'),
			new CCol($creationDateTxt, 'wraptext'),
			new CCol($size, 'wraptext'),
			(new CLink('restore','elisa_archive.php?action=indices.massrestore&indicesid='.$name))->addSID()
		));
		
	}
	
	//zbx_add_post_js('chkbxRange.pageGoName = "indicesid";');
	zbx_add_post_js('cookie.prefix = "indicesid";');
	// append table to form

	$actionList = new CActionButtonList('action', 'indicesid',
		[
			'indices.massrestore' => ['name' => _('Restore'),	'confirm' => _('Restore selected indices?')],
		],
		'indicesid'
	);

	$archivesForm = (new CForm())->setName('archivesForm');
	$archivesForm->addItem($archiveTable);
	$archivesForm->addItem($actionList);
	
	
	$archiveTab->addTab('data', _('Archived data'), $archivesForm);


	

// append form to widget
$archiveWidget->addItem($archiveTab);


return $archiveWidget;
