<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


$backupWidget = (new CWidget())->setTitle(_('Backup'));


$backupTab = new CTabView();

	$config = $this->data['config'];
	$help = $this->data['help'];
	
	
	$backupNfsForm = new CForm();
	$backupNfsForm->setName('backupNfsForm');

	$configNfsFormList = new CFormList('backupNfsForm');
	
	if($config['localpath']){
		$configNfsFormList->addRow(new CLabel($help['localpath']['label']), (new CSpan($help['localpath']['hint']))->addClass('yellow'));
	}
	if($config['nfs']!=""){
		$configNfsFormList->addRow(new CLabel($help['nfs']['label']), new CSpan($config['nfs']));
		$configNfsFormList->addRow(new CLabel($help['nfsavail']['label']), new CSpan($config['nfsavail']));
		$configNfsFormList->addRow(new CSubmit('umount', _('Umount')));
		$configNfsFormList->addRow(new CSpan(''));

		
	}else{
		$nfsBox = (new CTextBox('nfs', $config['nfs'], false, ZBX_TEXTAREA_STANDARD_WIDTH))->addStyle('width: 30em');
		$nfsLabel = new CLabel($help['nfs']['label']);
		if($help['nfs']['hint']!=null){$nfsLabel->setHint($help['nfs']['hint'],'',false);}
		$configNfsFormList->addRow($nfsLabel, $nfsBox);
		$configNfsFormList->addRow(new CSubmit('mount', _('Mount')));
		$configNfsFormList->addRow(new CSpan(''));
	}


	$ret1Box = (new CTextBox('BACKUP_DELETE', $config['BACKUP_DELETE'], false, ZBX_TEXTAREA_STANDARD_WIDTH))->addStyle('width: 5em');
	$ret1Label = new CLabel($help['BACKUP_DELETE']['label']);
	if($help['BACKUP_DELETE']['hint']!=null){$ret1Label->setHint($help['BACKUP_DELETE']['hint'],'',false);}
	$configNfsFormList->addRow($ret1Label, $ret1Box);

	$valueBox = new CCheckBox('BACKUP_ZABBIX_HISTORY_DATA', 1);
	if($config['BACKUP_ZABBIX_HISTORY_DATA']==1){$valueBox->setChecked(true);}
	$valueLabel = new CLabel($help['BACKUP_ZABBIX_HISTORY_DATA']['label']);
	if($help['BACKUP_ZABBIX_HISTORY_DATA']['hint']!=null){$valueLabel->setHint($help['BACKUP_ZABBIX_HISTORY_DATA']['hint'],'',false);}
	$valueBox->onChange('if(jQuery(this).is(":checked")){jQuery("input[type=\"hidden\"][name=\"BACKUP_ZABBIX_HISTORY_DATA\"]").prop("disabled",true);}else{jQuery("input[type=\"hidden\"][name=\"BACKUP_ZABBIX_HISTORY_DATA\"]").prop("disabled",false)};');
	$configNfsFormList->addRow($valueLabel, $valueBox);
	$hiddenBox = new CInput('hidden','BACKUP_ZABBIX_HISTORY_DATA',0);
	if($config['BACKUP_ZABBIX_HISTORY_DATA']==1){$hiddenBox->setEnabled(false);}
	$configNfsFormList->addItem($hiddenBox);
	
	$backupNfsForm->addItem($configNfsFormList);
	
	$backupNfsForm->addItem(makeFormFooter(new CSubmit('update', _('Update')),[new CSubmit('backupnow', _('Run backup now'))]));


	$backupTab->addTab('config', _('Configuration'), $backupNfsForm);
	
	
	$backupTable = new CTableInfo(_('No backup files found.'));
	$backupTable->setHeader(array(
		_('Name'),
		_('Creation Date'),
		_('Size'),
		_('Action')
	));
	foreach ($this->data['files'] as $name => $file) {
		$creationDate = $file['creationDate']/1000;
		if($creationDate>0){
			$creationDateTxt = date('d.m.Y H:i:s',$creationDate);
		}else{
			$creationDateTxt = '';
		}
		if(array_key_exists('size_in_bytes',$file) && !is_null($file['size_in_bytes'])){
			$sizeOpt = array(
				'value' => $file['size_in_bytes'],
				'units' => 'B'
			);
			$size = convert_units($sizeOpt);
		}else{
			$size = '';
		}		

		$backupTable->addRow(array(
			new CCol($name, 'wraptext'),
			new CCol($creationDateTxt, 'wraptext'),
			new CCol($size, 'wraptext'),
			(new CLink(_('restore'),'elisa_backup.php?restore=force&backupid='.$name))->addConfirmation(_('Confirm system restore request please'))->addSID()
		));
		
	}
	

	$backupsForm = (new CForm())->setName('backupsForm');
	$backupsForm->addItem($backupTable);
	
	
	$backupTab->addTab('data', _('Backup files'), $backupsForm);


	

// append form to widget
$backupWidget->addItem((new CDiv())->AddItem(_('System backup can be used for restoring configuration after system failure.')));
$backupWidget->addItem((new CTag('br')));
$backupWidget->addItem($backupTab);


return $backupWidget;
