<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


$configWidget = (new CWidget())->setTitle(_('ELISA Options'));


// create form
$configForm = new CForm();
$configForm->setName('configForm');

$formLists = array();

foreach ($this->data['config'] as $key => $value) {
	
	if (array_key_exists($key, $this->data['help'])){
		$category = $this->data['help'][$key]['category'];
		$label = $this->data['help'][$key]['label'];
		$hint = $this->data['help'][$key]['hint'];
		$htmlType = $this->data['help'][$key]['htmlType'];
	}else{
		$category = 'Others';
		$label = $key;
		$hint = null;
		$htmlType = 'text';
	}
	
	if ( ! array_key_exists($category, $formLists)) {
		$formLists[$category] = array();
	}
	
	$formLists[$category][$key] = array(
		'value' => $value,
		'label' => $label,
		'hint' => $hint,
		'htmlType' => $htmlType
	);
	
}

$category_prev = '';
$configTab = new CTabView();
foreach ($formLists as $category => $arr1) {
	reset($arr1);
	$first_key = key($arr1);
	$configFormList = new CFormList($first_key);
	foreach ($arr1 as $key => $arr2) {	
		if($arr2['htmlType']=='checkbox'){
			$valueBox = new CCheckBox('items['.$key.']', 1);
			if($arr2['value']==1){$valueBox->setChecked(true);}
			$valueLabel = new CLabel($arr2['label']);
			if($arr2['hint']!=null){$valueLabel->setHint($arr2['hint'],'',false);}
			$valueBox->onChange('if(jQuery(this).is(":checked")){jQuery("input[type=\"hidden\"][name=\"items['.$key.']\"]").prop("disabled",true);}else{jQuery("input[type=\"hidden\"][name=\"items['.$key.']\"]").prop("disabled",false)};');
			$configFormList->addRow($valueLabel, $valueBox);
			$hiddenBox = new CInput('hidden','items['.$key.']',0);
			if($arr2['value']==1){$hiddenBox->setEnabled(false);}
			$configFormList->addItem($hiddenBox);
		}else{
			if( $data['DISABLE_INDICE_DELETE'] && ($key == "DATA_RETENTION_DELETE" || $key == "DATA_RETENTION_ARCHIVEDELETE")){
				$valueLabel = new CLabel($arr2['label']);
				if($arr2['hint']!=null){$valueLabel->setHint($arr2['hint'],'',false);}
				$configFormList->addRow($valueLabel, $arr2['value']);
				$hiddenBox = new CInput('hidden','items['.$key.']',$arr2['value']);
				$configFormList->addItem($hiddenBox);
			}else{
				$valueBox = (new CTextBox('items['.$key.']', $arr2['value'], false))->setWidth(ZBX_TEXTAREA_SMALL_WIDTH);
				if( strpos($arr2['label'], '\n') !== false ) {
					$labelArr = explode('\n',$arr2['label']);
					$valueLabel = new CSpan();
					foreach($labelArr as $k=>$l) {
						if($k > 0){$valueLabel->addItem(new CTag('BR'));}
						$valueLabel->addItem($l);
					}
				}else{
					$valueLabel = new CLabel($arr2['label']);
				}
				if($arr2['hint']!=null){
					
					if( substr($arr2['hint'], 0, 8) === 'CAUTION:' || substr($arr2['hint'], 0, 6) === 'POZOR:') {
						$valueLabel->addClass(ZBX_STYLE_YELLOW);
						$valueLabel->setHint($arr2['hint'],ZBX_STYLE_YELLOW,false);
					}else{
						$valueLabel->setHint($arr2['hint'],'',false);
					}
				}
				$configFormList->addRow($valueLabel, $valueBox);
				//$configFormList->addInfo('AAA');
			}
		}				
		//if($arr2['hint']!=null){$configFormList->addInfo($arr2['hint'],' ');}
	}
	
	$configTab->addTab($first_key, $category, $configFormList);
	
}

// Data buckets
$bucketTable = (new CTableInfo()); //->addStyle('width:0;');
$bucketTable->setHeader(array(_('Data logstorages'),_('Alias'),(new CLabel(_('Close indices after N days')))->setHint(_('-1=default'),'',false),(new CLabel(_('Delete indices after N days')))->setHint(_('-1=default'),'',false),(new CLabel(_('Archive indices after N days *')))->setHint(_('-1=default, 0=don\'t archive'),'',false),(new CLabel(_('Delete archives after N days *')))->setHint(_('-1=default, 0=don\'t delete archive'),'',false) ));
foreach ($this->data['bucket'] as $key => $bucket) {
	$name = _('logstorage').' '.$key;
	$alias = (new CTextBox('items[DATA_BUCKET_'.$key.'_ALIAS]', $bucket['ALIAS'], false))->setWidth(ZBX_TEXTAREA_SMALL_WIDTH);
	$close = (new CTextBox('items[DATA_BUCKET_'.$key.'_CLOSE]', $bucket['CLOSE'], false))->setWidth(ZBX_TEXTAREA_TINY_WIDTH);
	$delete = (new CTextBox('items[DATA_BUCKET_'.$key.'_DELETE]', $bucket['DELETE'], false))->setWidth(ZBX_TEXTAREA_TINY_WIDTH);
	$archive = (new CTextBox('items[DATA_BUCKET_'.$key.'_ARCHIVE]', $bucket['ARCHIVE'], false))->setWidth(ZBX_TEXTAREA_TINY_WIDTH);
	$archivedelete = (new CTextBox('items[DATA_BUCKET_'.$key.'_ARCHIVEDELETE]', $bucket['ARCHIVEDELETE'], false))->setWidth(ZBX_TEXTAREA_TINY_WIDTH);
	$bucketTable->addRow(array($name,$alias,$close,$delete,$archive,$archivedelete));
}
$bucketDiv = new CDiv();
$bucketDiv->addItem((new CTag('h3',true))->addItem(_('Logstorage information')));
$bucketDivInfo = new CDiv(_('Alternative logstorages can be used for storing data separately from the default \'elisa\' logstorage. This can be used to specify different data retention.'));
$bucketDiv->addItem($bucketDivInfo);
$bucketDiv->addItem((new CTag("br")));
$bucketDiv->addItem((new CTag("br")));
$bucketDiv->addItem($bucketTable);
$configTab->addTab("bucket", _('Data logstorages'), $bucketDiv);
	


$buttons = [ new CButtonCancel() ];
$saveButton = new CSubmit('update', _('Update'));
/*$saveButton->attr('data-removed-count', 0);
$saveButton->addClass('main');*/

$configTab->setFooter(makeFormFooter(new CSubmit('update', _('Update')), $buttons));

$configForm->addItem($configTab);	

// append form to widget
$configWidget->addItem($configForm);


return $configWidget;
