<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


/* WIDGET - CELA STRANKA*/
$licWidget = (new CWidget())->setTitle(_('ELISA License'));

/* TABY PRES CELOU STRANKU */
$licTab = new CTabView();

	/* OBSAH TABU "WEB" */
	/* DIV s obsahem tabu WEB */
	$formDiv = new CDiv();
	
	$formDiv->addItem((new CTag('h3',true))->addItem(_('License information')));

	$licTable = (new CFormList());
	$licVersion = $data['licVersion'];
	$licIssuedFor = $data['licIssuedFor'];
	$licIssuedForVat = $data['licIssuedForVat'];
	$licIpAddress = $data['licIpAddress'];
	$licExpiration = $data['licExpiration'];
	$elisaHostsLic = $data['elisaHostsLic'];
	$elisaHostsNow = $data['elisaHostsNow'];
	if($data['valid']){
		$licStatus = (new CDiv(_($data['licStatus'])))->AddClass('green');
	}else{
		$licStatus = (new CDiv(_($data['licStatus'])))->AddClass('red');
	}
	$licTable->addRow(_('Status:'),$licStatus);
	$licTable->addRow(_('ELISA version:'),$licVersion);
	$licTable->addRow(_('Company:'),$licIssuedFor);
	$licTable->addRow(_('Company VAT:'),$licIssuedForVat);
	$licTable->addRow(_('IP Address:'),$licIpAddress);
	$licTable->addRow(_('Expiration date:'),$licExpiration);
	
	$licSourceTable = (new CTable())->AddStyle('width:auto;');
	if($elisaHostsLic>999999 || $elisaHostsLic=="unlimited"){
		$elisaHostsLicPrint = _('unlimited');
	}else{
		$elisaHostsLicPrint = $elisaHostsLic;
	}
	$licSourceTable->addRow([_('Licensed'),$elisaHostsLicPrint]);
	if($elisaHostsLic<$elisaHostsNow){
		$elisaHostsNow = (new CDiv($elisaHostsNow))->AddClass('red');
	}else{
		$elisaHostsNow = (new CDiv($elisaHostsNow));		
	}
	$licSourceTable->addRow([_('Consumed'),$elisaHostsNow]);
	$licTable->addRow(_('Sources count:'),$licSourceTable);
	
	$formDiv->addItem((new CTag('br')));
	$formDiv->addItem($licTable);
	

	$formDiv->addItem((new CTag('br')));
	$formDiv->addItem((new CTag('br')));
	
	$formDiv->addItem((new CTag('h3',true))->addItem(_('Install new license')));
	$formDiv->addItem((new CTag('br')));
	
	$formForm = new CForm('post', null, 'multipart/form-data');

		$formFormList = (new CFormList());
		$formFormList->addRow(_('License file:'), (new CFile('licfile'))->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH));
		$formForm->addItem($formFormList);
		$formForm->addItem(makeFormFooter(
			new CSubmit('update', _('Update')),
			[new CRedirectButton(_('Cancel'), $data['backurl'])]
		));
	$formDiv->addItem($formForm);
	

	
$licTab->addTab('form', _('Form'), $formDiv);











// append form to widget
$licWidget->addItem($licTab);

return $licWidget;
