<?php
/*
** Zabbix
** Copyright (C) 2001-2015 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


$sourcesWidget = (new CWidget())->setTitle(_('ELISA Logsources'));
	$sourcesWidget->setWebLayoutMode((int)$this->data['getLayoutMode']);
	$sourcesWidget->addItem(new CTag('Style',true,'button.layout-mode {display:none;}'));
	//$sourcesWidget->setWebLayoutMode(CView::getLayoutMode());
	//$sourcesWidget->setControls((new CList())->addItem(get_icon('fullscreen')));


// filter
$sourcesWidget->addItem(
	(new CFilter(new CUrl('elisa_logsources.php')))
		->setProfile($data['profileIdx'])
		->setActiveTab($data['active_tab'])
		->addFilterTab(_('Filter'), [
			(new CFormList)
				->addRow(_('Host'), (new CTextBox('filter_host_value', $this->data['filterHostValue']))->setWidth(ZBX_TEXTAREA_SMALL_WIDTH)->setAttribute('autofocus', 'autofocus'))
				->addRow(_('Input'), (new CTextBox('filter_input_value', $this->data['filterInputValue']))->setWidth(ZBX_TEXTAREA_SMALL_WIDTH))
			,
			(new CFormList)
				->addRow(_('Last event before'), (new CDateSelector('filter_lasteventdate_value', $this->data['filterLasteventdateValue']))->setDateFormat(ZBX_FULL_DATE_TIME))
				/*->addRow(_('Include \'no data\' input'), (new CCheckBox('filter_nodata_value'))->setChecked($this->data['filterNodataValue'] == 1))*/
		])
);


// create form
$sourcesForm = (new CForm())->setName('sourcesForm');

// create user group table
$sourcesTable = new CTableInfo(_('No Logsources found.'));
$sourcesTable->setHeader(array(
	make_sorting_header(_('Host'), 'host', $this->data['sort'], $this->data['sortorder']),
	make_sorting_header(_('Input'), 'input', $this->data['sort'], $this->data['sortorder']),
	make_sorting_header(_('Creation Date'), 'creationdate', $this->data['sort'], $this->data['sortorder']),
	make_sorting_header(_('Last event Date'), 'lastdate', $this->data['sort'], $this->data['sortorder']),
	make_sorting_header(_('Inactivity Detection'), 'deadPerc', $this->data['sort'], $this->data['sortorder']),
	_('Inactivity Interval'),
	_('Remove')
));


foreach ($this->data['sources'] as $source) {

	$hostName = (new CLinkAction($source['host']))->setMenuPopup(CMenuPopupHelper::getHost($source['hostid']));

	$creationDate = $source['creationdate'];
	if($creationDate>0){
		$creationDateTxt = date('d.m.Y H:i:s',$creationDate);
	}else{
		$creationDateTxt = '';
	}
	$lastDate = $source['lastdate'];
	if($lastDate>0){
		$lastDateTxt = date('d.m.Y H:i:s',$lastDate);
	}else{
		$lastDateTxt = '';
	}
	
	
	$deadPerc = "";
	if($source['deadPerc']>=0){$deadPerc = $source['deadPerc']." %";}
	
	$class = '';
	if($source['deadPerc']>=100){ $class = 'disaster-bg'; }
	else if($source['deadPerc']>=75){ $class = 'average-bg'; }
	else if($source['deadPerc']>=50){ $class = 'warning-bg'; }
	if($lastDateTxt == ''){ $class = 'na-bg'; }
	$remove = new CSpan('');
	if($source['admin']){
		$remove = (new CLink(_('remove'),'elisa_logsources.php?action=remove&hostname='.$source['host'].'&hostid='.$source['hostid'].'&source='.$source['input']))->addConfirmation(_('Delete item?'))->addSID();
	}
	
	$row = (new CRow(
		array(
			new CCol($hostName, 'wraptext'),
			new CCol($source['input'], 'wraptext'),
			new CCol($creationDateTxt, 'wraptext'),
			new CCol($lastDateTxt, 'wraptext'),
			new CCol($deadPerc, 'wraptext'),
			new CCol($source['deadinterval'], 'wraptext'),
			new CCol($remove, 'wraptext')	
		)
	))->addClass($class);
	
	$sourcesTable->addRow($row);
}



$sourcesForm->addItem([
	$sourcesTable, 
	$this->data['paging']
]);


// append form to widget
$sourcesWidget->addItem($sourcesForm);

return $sourcesWidget;
