<?php
/*
** script for generate PDF file from zabbix screens
**/

define('WKHTMLTOPDF','/usr/local/bin/wkhtmltopdf');
define('TMP_FOLDER','/tmp/zabbixpdf/');
define('PDF_CSS_SCREEN','/usr/share/zabbix/wkhtmltopdf/zabbix-screen.css');
define('PDF_CSS_REPORT2','/usr/share/zabbix/wkhtmltopdf/zabbix-report.css');
define('PDF_THEME','blue-theme');
define('PDF_ROWSPERPAGE','1000');
define('ZABBIX_URL','https://localhost/zabbix/');

require_once dirname(__FILE__).'/include/config.inc.php';
require_once dirname(__FILE__).'/include/js.inc.php';

$fields = array(
	'screenid' 	=>		[T_ZBX_INT, O_OPT, null,	null,	null],
	'stime' 	=>		[T_ZBX_STR, O_OPT, null,	null,	null],
	'period' 	=>		[T_ZBX_STR, O_OPT, null,	null,	null],
	'source' 	=>		[T_ZBX_STR, O_OPT, null,	null,	null],
	'groupid' 	=>		[T_ZBX_INT, O_OPT, null,	null,	null],
	'hostid' 	=>		[T_ZBX_INT, O_OPT, null,	null,	null],
	'hscreenid' =>		[T_ZBX_SINT, O_OPT, null,	null,	null]
);

check_fields($fields);

if (!file_exists(TMP_FOLDER)) {
	mkdir(TMP_FOLDER, 0700, true);
}

/* delete old pdf files in tml folder */
$files = glob(TMP_FOLDER.'*');
$now = time();
foreach ($files as $file){
	if (is_file($file)){
		if ($now - filemtime($file) >= 60 * 60){ // 1 hour
			unlink($file);
		}
	}
}

$sessionid = $_COOKIE['zbx_sessionid'];
$rand = mt_rand();


$wkhtmltopdfurl = '';


#if (hasRequest('screenid') && hasRequest('stime') && hasRequest('period')){
if (hasRequest('screenid')){
	
	#$wkhtmltopdfurl = WKHTMLTOPDF.' --cookie zbx_sessionid '.$sessionid.' --no-background --footer-left "[date] [time],   Datasys s.r.o." --footer-font-size 8 --user-style-sheet "'.PDF_CSS.'" "'.ZABBIX_URL.'screens.php?elementid='.getRequest('screenid').'&stime='.getRequest('stime').'&period='.getRequest('period').'" '.TMP_FOLDER.'zabbix01.pdf';
	$wkhtmltopdfurl = WKHTMLTOPDF.' --cookie zbx_sessionid '.$sessionid.' --no-background --footer-left "[date] [time],   Datasys s.r.o." --footer-font-size 8 --user-style-sheet "'.PDF_CSS_SCREEN.'" --orientation Portrait --page-size A4 "'.ZABBIX_URL.'screens.php?elementid='.getRequest('screenid').'" '.TMP_FOLDER.'zabbix_'.$rand.'.pdf';
	
}else if(getRequest('source') == 'report2'){
		
	$wkhtmltopdfurl = WKHTMLTOPDF.' --cookie zbx_sessionid '.$sessionid.' --no-background --footer-left "[date] [time],   Datasys s.r.o." --footer-font-size 8 --user-style-sheet "'.PDF_CSS_REPORT2.'" --orientation Portrait --page-size A4 "'.ZABBIX_URL.'report2-sla_dts.php" '.TMP_FOLDER.'zabbix_'.$rand.'.pdf';
	
}else if(getRequest('source') == 'hostscreen'){
		
	$wkhtmltopdfurl = WKHTMLTOPDF.' --cookie zbx_sessionid '.$sessionid.' --no-background --footer-left "[date] [time],   Datasys s.r.o." --footer-font-size 8 --user-style-sheet "'.PDF_CSS_SCREEN.'" --orientation Portrait --page-size A4 --zoom 0.5 "'.ZABBIX_URL.'host_screen_dts.php?groupid='.getRequest('groupid').'&hostid='.getRequest('hostid').'&hscreenid='.getRequest('hscreenid').'" '.TMP_FOLDER.'zabbix_'.$rand.'.pdf';

}


if($wkhtmltopdfurl != ''){
	
	/* nastavit theme jednorazove na svetle */
	$userData = DBfetch(DBselect('select u.theme, u.rows_per_page FROM users u WHERE u.userid='.zbx_dbstr(CWebUser::$data['userid'])));
	$userTheme = $userData['theme'];
	$userRowsPerPage = $userData['rows_per_page'];
	$sql = 'update users set theme='.zbx_dbstr(PDF_THEME).', rows_per_page='.zbx_dbstr(PDF_ROWSPERPAGE).' where userid='.zbx_dbstr(CWebUser::$data['userid']);
	DBexecute($sql);
	
	exec($wkhtmltopdfurl);
	
	/* vratit puvodni uzivatelovo theme */
	$sql = 'update users set theme='.zbx_dbstr($userTheme).', rows_per_page='.zbx_dbstr($userRowsPerPage).' where userid='.zbx_dbstr(CWebUser::$data['userid']);
	DBexecute($sql);
	
	/* vratit pdf jako response */
	$file = TMP_FOLDER.'zabbix_'.$rand.'.pdf';
	$pdf = file_get_contents($file);

	header('Content-Type: application/pdf');
	header('Cache-Control: public, must-revalidate, max-age=0'); // HTTP/1.1
	header('Pragma: public');
	header('Expires: Sat, 26 Jul 1997 05:00:00 GMT'); // Date in the past
	header('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT');
	header('Content-Length: '.strlen($pdf));
	header('Content-Disposition: inline; filename="'.basename($file).'";');
	ob_clean(); 
	flush(); 
	echo $pdf;
	
}else{
	
	echo 'Unsupported parameters';
	
}

?>	


